//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//using Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Gymna.dll;

using System;
using System.Diagnostics;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Gymna.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Gymna.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Gymna.BusinessObjects;
using Produmex.Sbo.Logex.Gymna.Generators.PickListRobot;


namespace AddUpdateScript
{
    class Program
    {
		static string CONNECTION_STRING = "Server=VM_DEV_64;CompanyDB=SBODemo_US_52;ExtraDb=SBODemo_US_52_PMX_EX;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000";        

        /// <summary>
        /// Used for logging
        /// </summary>
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

        static void Main(string[] args)
        {
            try
            {
                Produmex.Foundation.Diagnostics.LogProvider.SetConsoleAppender("WARN");
                Execute();
            }
            catch (Exception ex)
            {
                s_log.Error("", ex);
            }
            if (Debugger.IsAttached)
            {
                Console.WriteLine("Press <Enter>");
                Console.ReadLine();
            }
        }

        static void Execute()
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    // PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);

                    SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider( conn );

                    // * UDF's *
                    SboColumnDefinitionAttribute ColumnDef = new SboColumnDefinitionAttribute( PmxSalesDeliveryNoteGTable.Columns.TotalWeight.NAME,
                        PmxSalesDeliveryNoteGTable.Columns.TotalWeight.DESCR, PmxSalesDeliveryNoteGTable.Columns.TotalWeight.TYPE,
                        PmxSalesDeliveryNoteGTable.Columns.TotalWeight.SIZE,
                        PmxSalesDeliveryNoteGTable.Columns.TotalWeight.SUB_TYPE );
                    udfProv.AddUpdateUserfield( SboSalesDeliveryNoteTable.NAME, ColumnDef );

                    ColumnDef = new SboColumnDefinitionAttribute( PmxSalesDeliveryNoteGTable.Columns.NumberOfColli.NAME,
                        PmxSalesDeliveryNoteGTable.Columns.NumberOfColli.DESCR, PmxSalesDeliveryNoteGTable.Columns.NumberOfColli.TYPE,
                        PmxSalesDeliveryNoteGTable.Columns.NumberOfColli.SIZE, PmxSalesDeliveryNoteGTable.Columns.NumberOfColli.SUB_TYPE );
                    udfProv.AddUpdateUserfield( SboSalesDeliveryNoteTable.NAME, ColumnDef );

                    // Created by customer (?)
                    //ColumnDef = new SboColumnDefinitionAttribute(
                    //    PmxStockTransferRequestTableG.Columns.SalesOrderDocNum.NAME,
                    //    PmxStockTransferRequestTableG.Columns.SalesOrderDocNum.DESCR,
                    //    PmxStockTransferRequestTableG.Columns.SalesOrderDocNum.TYPE,
                    //    PmxStockTransferRequestTableG.Columns.SalesOrderDocNum.SIZE,
                    //    PmxStockTransferRequestTableG.Columns.SalesOrderDocNum.SUB_TYPE);
                    //udfProv.AddUpdateUserfield(PmxStockTransferRequestTableG.NAME, ColumnDef);

					
					PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);

					//Pick list type
					updateProv.AddUpdateUserDefinedTable(typeof(PmxPickListTypeG));
					updateProv.AddUpdateUserDefinedObject(typeof(PmxPickListTypeG));

					updateProv.AddUpdateExtension(PickListRobot.IDs.ExtCode, "Gymna Pick List robot",
						typeof(Produmex.Sbo.Logex.Gymna.Generators.PickListRobot.PickListRobot), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IPICKLISTROBOT);



                    Console.WriteLine( "Client Parameters" );

                    PmxDbVersionUpdaterProvider dbVersionProv = new PmxDbVersionUpdaterProvider( conn );

                    dbVersionProv.AddUpdateExtensionParameter( PmxExtensionParameterCodesG.GLS_OUT_DIR,
                        "G - GLS output directory",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"C:\Produmex\Interface\Out\GLS",
                        PmxExtensionParameterCodesG.GLS_OUT_DIR.Substring( 2 ) );

					Assembly gymnaAssembly = typeof(Produmex.Sbo.Logex.Gymna.SboCommands).Assembly;

					////Don't update the views, because thay could have been updated.

					//string resourceName = "Produmex.Sbo.Logex.Gymna.Scripts.Views.PMX_G_OPEN_SALES_ORDER_LINES.sql";
					//conn.DbTool.CreateUpdateView("PMX_G_OPEN_SALES_ORDER_LINES", dbVersionProv.PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(gymnaAssembly, resourceName)));

					//resourceName = "Produmex.Sbo.Logex.Gymna.Scripts.Views.PMX_G_OPEN_WHS_TRANSFER_LINES.sql";
					//conn.DbTool.CreateUpdateView("PMX_G_OPEN_WHS_TRANSFER_LINES", dbVersionProv.PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(gymnaAssembly, resourceName)));

					//resourceName = "Produmex.Sbo.Logex.Gymna.Scripts.Views.PMX_G_PROPOSALS_TO_PICK_LIST.sql";
					//conn.DbTool.CreateUpdateView("PMX_G_PROPOSALS_TO_PICK_LIST", dbVersionProv.PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(gymnaAssembly, resourceName)));


					AddUpdatePmxConfig(PmxConfigCodesGymna.GLS_ACCOUNT_NUMBER_PARCEL, "GYMNA - GLS Account code parcels", 
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR, 
						"100730540", conn);

					AddUpdatePmxConfig(PmxConfigCodesGymna.GLS_ACCOUNT_NUMBER_FREIGHT, "GYMNA - GLS Account code freight",
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						"8565493", conn);

				}
                scope.Complete();
            }


            //PMX connection
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                    dbConn.Open();

                    Console.WriteLine("Views");



                    //Complete transaction
                    scope.Complete();
                }
            }


            Console.WriteLine("Done ...");
        }


		/// <summary>
		/// Add/update application type
		/// </summary>
		/// <param name="code">The code of the config</param>
		/// <param name="name">The name of the config</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="configValue">The config value.</param>
		/// <param name="conn">The connection.</param>
		private static void AddUpdatePmxConfig(string code, string name, string convertorCode, string configValue, SboConnection conn)
		{
			PmxConfigProvider prov = new PmxConfigProvider(conn);
			PmxConfig bo = null;
			try
			{
				bool newBo = false;
				bo = prov.GetBO(code);
				if (bo == null)
				{
					newBo = true;
					bo = prov.GetNewBO();
					bo.Code = code;
				}
				bo.Name = name;
				bo.ConvertorCode = convertorCode;
				bo.IsSystemConfig = false;
				if (newBo)
				{
					bo.ConfigValue = configValue;
					prov.AddBO(bo);
				}
				else
				{
					prov.UpdateBO(bo, false, false);
				}
			}
			finally
			{
				if (bo != null) bo.Dispose();
			}
		}




        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }



        }

        /// <summary>
        /// Runs the table SQL script.
        /// </summary>
        /// <param name="tableScript">The table script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Gymna.SboCommands)), "Produmex.Sbo.Logex.Gymna.Scripts.Tables." + tableScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }

        /// <summary>
        /// Adds the update user fields not in transaction.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="types">The types.</param>
        private static void AddUpdateUserFieldsNotInTransaction(SboConnection conn, params Type[] types)
        {
            SboUserFieldMDProvider userFieldMDProv = new SboUserFieldMDProvider(conn);
            //System.Data.Common.DbTransaction transaction = null;
            try
            {
                //transaction = this.Connection.BeginTransaction();
                userFieldMDProv.AddUpdateUserFields(types);

                //Commit transaction
                //transaction.Commit();
            }
            catch (Exception)
            {
                //if (transaction != null) transaction.Rollback();
                throw;
            }
        }

        /// <summary>
        /// Runs the stored procedure SQL script.
        /// </summary>
        /// <param name="spScript">The sp script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunStoredProcedureSqlScript(string spScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Gymna.SboCommands)), "Produmex.Sbo.Logex.Gymna.Scripts.StoredProcedures." + spScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }


    }
}
